/*
 * SoulGemLedControl.c
 *
 * Created: 2013/01/16 21:35:59
 *  Author: serio
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>

static unsigned char LEDBRIGHTNESS=0;
static unsigned short CYCLE=0;

// 邳ύXp[^(16iK*2)
static const unsigned char LED_PWMprm[]={
//	1,1,2,2,4,8,13,15,15,13,8,4,2,2,1,1
	1,2,3,5,8,12,15,18,20,23,25,27,28,29,30,31,
	31,30,29,28,27,25,23,20,18,15,12,8,5,3,2,1
};

// 邳ύX邽߂̃^C}[荞
// n msƂPWM̃~bgύXĂ(邳ς)܂
ISR(TIM0_OVF_vect)
{
	CYCLE++;
	if (CYCLE<1) return;
	CYCLE=0;
	LEDBRIGHTNESS++;	
	LEDBRIGHTNESS&=0x1f;
	OCR1B=LED_PWMprm[LEDBRIGHTNESS]*8;
//	if (LEDBRIGHTNESS & 1) PORTB=_BV(PORTB3);
//	else PORTB=0;			
}

// |[g
// LEDOC0Ao͂ɂĒڃhCuăRg[
static void init_ports(void)
{
	DDRB=_BV(DDB4);// | _BV(DDB3);	
}

static void init_pll(void)
{
	PRR=_BV(PRUSI); // SIU͒~
}

static void init_pwm(void)
{
	OCR1B=1;
	OCR1C=255;
	GTCCR=_BV(TSM) | _BV(COM1B1) | _BV(PWM1B); // PWM1B,JE^
	TCCR1=_BV(CS12) | _BV(CTC1);  // CK/128
	TCCR0B=_BV(CS02) | _BV(CS00); // CLK1/1024
	TIMSK=_BV(TOIE0); // Timer0 overflow
}

static void init_adc(void)
{
	DIDR0=_BV(ADC3D); // ADC3 Disable Digital input
	ADMUX=_BV(REFS2) | _BV(REFS1) | _BV(MUX1) | _BV(MUX0); // ADC3
	ADCSRA=_BV(ADEN) | _BV(ADSC) | _BV(ADATE) | _BV(ADPS2); // CK/16,AUTO,ENABLE
}

int main(void)
{
	volatile int n=0;
	
	init_pll();	//
	init_ports();
	init_pwm();
	init_adc();
	sei();	// 荞݋
    while(1)
    {
        //TODO:: Please write your application code 
		n++;
    }
}